#include "descriptor/descriptor.h"
#include <stdio.h>

/*	
 *	Progetto di grafica di Roberto Tassi - rtassi@cs.unibo.it
 *	
 *	Script per creazione animazione e scena
 *	HOWTO: Modificare la variabile save_animation per decidere cosa salvare
*/	



int main(void) {

	// variabili globali
	int save_animation = 1;			// se settato a 1 salva l'animazione
	int enable_bump_mapping = 1;		// 0,1 spegne o accende il bump mapping
	
	// ELEMENTI

	ITEM scene;
	
	ITEM Luce1,Luce2,Luce3;

	ITEM mongolfiera;
	ITEM vela,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12;
	ITEM cesta, gabbia, protezioni, corde, veletta, motori, bombola, sacchi;
	
	ITEM busto, sfera;
	
	ITEM quadro, cornice, poster;
	
	ITEM mobile, mobile_legno, mob_fronte1, mob_fronte2, mob_fronte_prof, mob_sx, mob_dx, mob_up, mob_down,
	mobile_cassetti, mobile_maniglie, mob_man1, mob_man2, mob_man3, mob_man4, mob_man5, mob_man6, mob_man7, mob_man8,
	mob_back, mob_p1, mob_p2, mob_p3, mob_p4, mobile_ripiano, mobile_specchio;
	
	ITEM tavolino, tavolino2, tav_piano, tav_piede1, tav_piede2, tav_piede_sotto;
	
	ITEM lampada, lamp_cappello, lamp_base;
	
	ITEM faretti;
	ITEM barra_faretti, sostegno_faretto1, sostegno_faretto2;
	ITEM faretto1,faretto2, faretto_metal, faretto_light, faretto_metal2, faretto_light2;
	
	ITEM stanza,parete_ant,parete_dx,parete_post,parete_sx,pavimento,soffitto;
	
	// ATTRIBUTI
	ITEM	tela, tela_azz, tela_bianca, intonaco, azzurro, rosso, nero, bianco, grigio, marmo,
		cromatura, cromatura_scura, ottone, rame, legno, legno_dorato, vimini;


	// LUCI
	set_background(0.675,0.855,0.953,TRUE);
	set_ambient_light(0.9,0.9,0.9,2.5);
		// LUCE ambiente di test
	//Luce1 = create_point_light(8.888,0.135,11.059,1,1,1,2,1000, "Luce1");
		
		// Luce lampada di sinistra (Temp. Colore verso il rosso)
		// Promemoria: int:3.2, dist:23 - colore: 1,0.93,0.90
	Luce1 = create_point_light(-7.2, -8.8, 5.4,  1,0.89,0.78,2.7,22, "Luce1");
		// Luce faretto1 verso il quadro (Temp. Colore blu)
	Luce2 = create_warn_light(-8.0,8.0,10.0, 3.2,9.9,-11.0, 0.99,0.99,1, 2.4,25,0,33.0,0,0.0,0.0,0.0,0.0, "Luce2");
		// Luce faretto2 verso la mongolfiera (Temp. Colore blu)
	Luce3 = create_warn_light(-9.0,8.0,10.0, 5,-9,-5, 0.99,0.99,1, 12,20,0,20.0,0,0.0,0.0,0.0,0.0, "Luce3");

		// ATTRIBUTO Tela
	tela = create_attribute("tela");
	set_color(tela,0.5,0.5,0.5,0.1,0.8);		// r,g,b, ambient, diffuse
	set_reflectivity(tela,0.1,2);			// specular, phongs's exp.
	set_transparency(tela, 0.4, 0.2, 0.0, 1);	// max trasp, min trasp, refrax index, trasp. power
	
		// ATTRIBUTO Tela Azzurra
	tela_azz = create_attribute("tela_azz");
	set_color(tela_azz,0.1,0.3,0.7,0.1,0.8);		// r,g,b, ambient, diffuse
	set_reflectivity(tela_azz,0.1,2);			// specular, phongs's exp.
	set_transparency(tela_azz, 0.3, 0.1, 0.0, 1);	// max trasp, min trasp, refrax index, trasp. power
	
		// ATTRIBUTO Tela Bianca
	tela_bianca = create_attribute("tela_bianca");
	set_color(tela_bianca,0.5,0.5,0.5,0.9,0.8);
	set_reflectivity(tela_bianca,0,1);
	set_transparency(tela_bianca, 0.3, 0.2, 0.0, 8);
	
		// ATTRIBUTO Marmo
	marmo = create_attribute("marmo");
	set_color(marmo,0.6,0.6,0.65,0.3,0.5);
	set_reflectivity(marmo,0.07,1);
	set_transparency(marmo, 0.4, 0.1, 0.1, 1);
	
		// ATTRIBUTO Intonaco
	intonaco = create_attribute("intonaco");
	set_color(intonaco,0.83,0.82,0.8,0.1,0.7);
	set_reflectivity(intonaco,0,12);
	
		// ATTRIBUTO Azzurro
	azzurro = create_attribute("azzurro");
	set_color(azzurro,0.4,0.69,1,0.05,0.3);
	set_reflectivity(azzurro,0,2);
	
		// ATTRIBUTO Rosso
	rosso = create_attribute("rosso");
	set_color(rosso,0.6,0.1,0.1,0.05,0.3);
	set_reflectivity(rosso,0.2,10);

		// ATTRIBUTO Nero
	nero = create_attribute("nero");
	set_color(nero,0,0,0,0.1,0.3);
	set_reflectivity(nero,0.3,5);
	
		// ATTRIBUTO Grigio
	grigio = create_attribute("grigio");
	set_color(grigio,0.20,0.24,0.20,0.24,0.20);
	set_reflectivity(grigio,0.15,30);

		// ATTRIBUTO Bianco
	bianco = create_attribute("bianco");
	set_color(bianco,1.0,1.0,1.0,0.0,0.9);
	set_reflectivity(bianco,0.0,0.0);
	
		// ATTRIBUTO Cromatura
	cromatura = create_attribute("cromatura");
	set_color(cromatura,0.3,0.3,0.3,0.2,0.2);
	set_reflectivity(cromatura,0.9,20);	// quantita' riflessione [0,1], riflesso bianco (meno a valori alti)

		// ATTRIBUTO Cromatura scura
	cromatura_scura = create_attribute("cromatura_scura");
	set_color(cromatura_scura,0.15,0.15,0.15,0.15,0.15);
	set_reflectivity(cromatura_scura,0.8,20);
	
		// ATTRIBUTO Rame (ossidato)
	rame = create_attribute("rame");
	set_color(rame,0.01,0.09,0.02,0.1,0.1);
	set_reflectivity(rame,0.2,10);
		
		// ATTRIBUTO Ottone
	ottone = create_attribute("ottone");
	set_color(ottone,0.78,0.7,0.42,0.1,0.1);
	set_reflectivity(ottone,0.4,15);
	
		// ATTRIBUTO Vimini
	vimini = create_attribute("vimini");
	if (enable_bump_mapping) {
		set_color(vimini,0.4,0.3,0.1,0.2,0.4);
		set_reflectivity(vimini,0.1,3);
	} else {
		set_color(vimini,0.4,0.3,0.1,0.1,0.2);
		set_reflectivity(vimini,0.25,1.5);
	}
	
			// ATTRIBUTO Legno
	legno = create_attribute("legno");
	set_color(legno,0.4,0.3,0.1,0.2,0.3);
	set_reflectivity(legno,0.05,1.5);
	
		// ATTRIBUTO Legno dorato
	legno_dorato = create_attribute("legno_dorato");
	set_color(legno_dorato,0.6,0.5,0.2,0.1,0.3);
	set_reflectivity(legno_dorato,0.25,1.5);


	/* MONGOLFIERA */

		// VELA MONGOLFIERA
	//vela = read_obj("baloon.obj", "vela");	// vecchio modo (carica tutto l'oggetto)
	// nuovo metodo: carico le singole parti della vela
	v1 = read_nurbs("1.db");   v2 = read_nurbs("2.db");   v3 = read_nurbs("3.db");
	v4 = read_nurbs("12.db");   v5 = read_nurbs("4.db");   v6 = read_nurbs("5.db");
	v7 = read_nurbs("6.db");   v8 = read_nurbs("7.db");   v9 = read_nurbs("8.db");
	v10 = read_nurbs("9.db"); v11 = read_nurbs("10.db"); v12 = read_nurbs("11.db");
	
	vela = create_list(v1, "vela");		vela = insert_in_list(vela, v2);
	vela = insert_in_list(vela, v3);	vela = insert_in_list(vela, v4);
	vela = insert_in_list(vela, v5);	vela = insert_in_list(vela, v6);
	vela = insert_in_list(vela, v7);	vela = insert_in_list(vela, v8);
	vela = insert_in_list(vela, v9);	vela = insert_in_list(vela, v10);
	vela = insert_in_list(vela, v11);	vela = insert_in_list(vela, v12);
	set_attribute(vela,tela);
	
	set_domain_texture(v1,  tela, "textures/v6.hr",0.0,0.5,0,1,1,0.3,0.4);
	set_domain_texture(v7,  tela, "textures/v6.hr",0.0,0.5,0,1,1,0.3,0.4);
	set_domain_texture(v2,  tela, "textures/v5.hr",0.0,0.5,0,1,1,0.3,0.4);
	set_domain_texture(v8,  tela, "textures/v5.hr",0.0,0.5,0,1,1,0.3,0.4);
	set_domain_texture(v3,  tela, "textures/v4.hr",0.0,0.5,0,1,1,0.3,0.4);
	set_domain_texture(v9,  tela, "textures/v4.hr",0.0,0.5,0,1,1,0.3,0.4);
	set_domain_texture(v4,  tela, "textures/v3.hr",0.0,0.5,0,1,1,0.3,0.4);
	set_domain_texture(v10, tela, "textures/v3.hr",0.0,0.5,0,1,1,0.3,0.4);
	set_domain_texture(v5,  tela, "textures/v2.hr",0.0,0.5,0,1,1,0.3,0.4);
	set_domain_texture(v11, tela, "textures/v2.hr",0.0,0.5,0,1,1,0.3,0.4);
	set_domain_texture(v6,  tela, "textures/v1.hr",0.0,0.5,0,1,1,0.3,0.4);
	set_domain_texture(v12, tela, "textures/v1.hr",0.0,0.5,0,1,1,0.3,0.4);
	set_translate(vela,-0.6,0.0,-0.0375);
	
		// GABBIA e MOTORE (e catene)
	gabbia = read_obj("gabbia_mot_cat.obj", "gabbia");
	set_attribute(gabbia, cromatura);
	
		// PROTEZIONI GABBIA
	protezioni = read_obj("prot.obj", "protezioni");
	set_attribute(protezioni, rosso);
	
		// CORDE
	corde = read_obj("corde.obj", "corde");
	set_attribute(corde, bianco);
	
		// CESTO MONGOLFIERA
	cesta = read_obj("cesta.obj", "cesta");
	set_attribute(cesta, vimini);
	if (enable_bump_mapping) {
		set_bump_texture(cesta, vimini, "textures/cesta1.hr", 0.0,0.5,0.0,0.8,1.0,0.2,0.1);
	} else	set_domain_texture(cesta, vimini, "textures/cesta1.hr", 0.0,0.5,0.0,0.8,1.0,0.3,0.4);
	
		// VELETTA PARAVENTO
	veletta = read_nurbs("veletta.db");
	set_attribute(veletta, tela_azz);
	
		// BOMBOLA GAS
	bombola = read_obj("gas.obj", "bombola");
	set_attribute(bombola, cromatura_scura);
	set_translate(bombola, 0,0,1.5);
	
		// SACCHI PESANTI
	sacchi = read_obj("sacchi.obj", "sacchi");
	set_attribute(sacchi, nero);
	
		// MONGOLFIERA
	mongolfiera = create_list(gabbia, "mongolfiera");
	mongolfiera = insert_in_list(mongolfiera, protezioni);
	mongolfiera = insert_in_list(mongolfiera, corde);
	mongolfiera = insert_in_list(mongolfiera, cesta);
	mongolfiera = insert_in_list(mongolfiera, vela);
	mongolfiera = insert_in_list(mongolfiera, veletta);
	mongolfiera = insert_in_list(mongolfiera, bombola);
	mongolfiera = insert_in_list(mongolfiera, sacchi);
	
	set_z_rotate(mongolfiera,60,1);
	set_scale(mongolfiera,0.007,0.007,0.007);
	//set_translate(mongolfiera,-2,0,4);	// vecchia posizione (a destra, vicino al quadro)
	set_translate(mongolfiera,-6.3,-2.8,4);


	/* RESTO DELLA STANZA */
	
			// QUADRO
	cornice = read_obj("cornice.obj", "cornice");
	set_attribute(cornice, legno_dorato);
	poster = read_nurbs("poster.db");
	set_attribute(poster, intonaco);
	set_domain_texture(poster, intonaco, "textures/mongolfiera.hr",0,1,0,1,0,0.3,0.4);
	
	quadro = create_list(cornice, "quadro");
	quadro = insert_in_list(quadro, poster);
	set_z_rotate(quadro, 270, 1);
	set_translate(quadro, -25, 28.4, 20);
	set_scale(quadro, 0.35,0.35,0.3);
	
			// MOBILE
	//mobile_legno = read_obj("mobile.obj", "mobile_legno");
	//set_attribute(mobile_legno, legno);
	mob_up = read_nurbs("mob_piano.db");	mob_down = read_nurbs("mob_fondo.db");
	mob_dx = read_nurbs("mob_dx.db");	mob_sx = read_nurbs("mob_sx.db");
	mob_back = read_nurbs("mob_retro.db");	mob_p1 = read_nurbs("mob_piede1.db");
	mob_p2 = read_nurbs("mob_piede2.db");	mob_p3 = read_nurbs("mob_piededx.db");
	mob_p4 = read_nurbs("mob_piedesx.db");
	mob_fronte1 = read_nurbs("mob_fronte1.db");
	mob_fronte2 = read_nurbs("mob_fronte2.db");
	mob_fronte_prof = read_nurbs("mob_fronte_prof.db");
	
	mobile_legno = create_list(mob_up, "mobile_legno");
	mobile_legno = insert_in_list(mobile_legno, mob_down);
	mobile_legno = insert_in_list(mobile_legno, mob_dx);
	mobile_legno = insert_in_list(mobile_legno, mob_sx);
	mobile_legno = insert_in_list(mobile_legno, mob_back);
	mobile_legno = insert_in_list(mobile_legno, mob_p1);
	mobile_legno = insert_in_list(mobile_legno, mob_p2);
	mobile_legno = insert_in_list(mobile_legno, mob_p3);
	mobile_legno = insert_in_list(mobile_legno, mob_p4);
	mobile_legno = insert_in_list(mobile_legno, mob_fronte1);
	mobile_legno = insert_in_list(mobile_legno, mob_fronte2);
	mobile_legno = insert_in_list(mobile_legno, mob_fronte_prof);
	set_attribute(mobile_legno, legno);
	set_domain_texture(mobile_legno, legno, "textures/legno.hr",0,0.6,0,0.6,1,0.3,0.4);
	
	mobile_cassetti = read_nurbs("mob_cassetti.db");
	set_attribute(mobile_cassetti, legno);
	set_domain_texture(mobile_cassetti, legno, "textures/legno_cassetti.hr",0,1,0,1,1,0.3,0.4);
	
	mob_man1 = read_obj("mob_maniglia.obj", "mob_man1");
	mob_man2 = read_obj("mob_maniglia.obj", "mob_man2");	set_translate(mob_man2, 0, 1, 0);
	mob_man3 = read_obj("mob_maniglia.obj", "mob_man3");	set_translate(mob_man3, 0, 0, -0.165);
	mob_man4 = read_obj("mob_maniglia.obj", "mob_man4");	set_translate(mob_man4, 0, 1, -0.165);
	mob_man5 = read_obj("mob_maniglia.obj", "mob_man5");	set_translate(mob_man5, 0, 0, -0.33);
	mob_man6 = read_obj("mob_maniglia.obj", "mob_man6");	set_translate(mob_man6, 0, 1, -0.33);
	mob_man7 = read_obj("mob_maniglia.obj", "mob_man7");	set_translate(mob_man7, 0, 0, -0.495);
	mob_man8 = read_obj("mob_maniglia.obj", "mob_man8");	set_translate(mob_man8, 0, 1, -0.495);
	
	mobile_maniglie = create_list(mob_man1, "mobile_maniglie");
	mobile_maniglie = insert_in_list(mobile_maniglie, mob_man2);
	mobile_maniglie = insert_in_list(mobile_maniglie, mob_man3);
	mobile_maniglie = insert_in_list(mobile_maniglie, mob_man4);
	mobile_maniglie = insert_in_list(mobile_maniglie, mob_man5);
	mobile_maniglie = insert_in_list(mobile_maniglie, mob_man6);
	mobile_maniglie = insert_in_list(mobile_maniglie, mob_man7);
	mobile_maniglie = insert_in_list(mobile_maniglie, mob_man8);
	set_attribute(mobile_maniglie, rame);
	
	mobile_ripiano = read_nurbs("mob_marmo.db");
	set_attribute(mobile_ripiano, marmo);
	set_y_rotate(mobile_ripiano, 90, 1);	// trasformazioni per effetto lastra marmo
	set_z_rotate(mobile_ripiano, -26, 1);
	set_x_rotate(mobile_ripiano, 6, 1);
	//set_domain_texture(mobile_ripiano, marmo, "textures/marmo_rosa.hr",0,1,0,1,1,0.2,0.3);
	set_projection_texture(mobile_ripiano, marmo, "textures/marmo_rosa.hr",0,1,0.3,0.4);
	set_x_rotate(mobile_ripiano, -6, 1);	// trasformazioni inverse
	set_z_rotate(mobile_ripiano, 26, 1);
	set_y_rotate(mobile_ripiano, -90, 1);
	
	mobile_specchio = read_nurbs("mob_specchio.db");
	set_attribute(mobile_specchio, cromatura_scura);
	
	mobile = create_list(mobile_legno, "mobile");
	mobile = insert_in_list(mobile, mobile_cassetti);
	mobile = insert_in_list(mobile, mobile_maniglie);
	mobile = insert_in_list(mobile, mobile_ripiano);
	mobile = insert_in_list(mobile, mobile_specchio);
	set_scale(mobile, 5, 5, 5);
	set_translate(mobile, -20.6, 0, 2.2);
	//set_translate(mobile, -6.6, 0, 2.2);	// al centro stanza
	
			// TAVOLINO destra
	tav_piano = read_nurbs("tav_piano.dbe");   tav_piede1 = read_nurbs("tav_piede1.dbe");
	tav_piede2 = read_nurbs("tav_piede2.dbe"); tav_piede_sotto = read_nurbs("tav_piede_down.dbe");

	tavolino = create_list(tav_piano, "tavolino");
	tavolino = insert_in_list(tavolino, tav_piede1);
	tavolino = insert_in_list(tavolino, tav_piede2);
	tavolino = insert_in_list(tavolino, tav_piede_sotto);
	set_attribute(tavolino, legno);
	set_domain_texture(tavolino, legno, "textures/legno.hr",0,1.2,0,1.2,1,0.3,0.4);
	set_z_rotate(tavolino, 180, 1);
	set_translate(tavolino, -3.0, 4.16, 0.57);
	set_scale(tavolino, 2.4,2.4,2.4);
	
			// TAVOLINO sinistra
	tavolino2 = read_obj("tavolino.obj", "tavolino2");
	set_attribute(tavolino2, legno);
	set_domain_texture(tavolino2, legno, "textures/legno.hr",0,1.2,0,1.2,1,0.3,0.4);
	set_translate(tavolino2, -3.0, -4.16, 0.57);
	set_scale(tavolino2, 2.4,2.4,2.4);
	
			// LAMPADA sx
	lamp_base = read_nurbs("lamp_base.db");
	set_attribute(lamp_base, ottone);
	lamp_cappello = read_nurbs("lamp_capp.db");
	set_attribute(lamp_cappello, tela_bianca);
	
	lampada = create_list(lamp_base, "lampada");
	lampada = insert_in_list(lampada, lamp_cappello);
	set_z_rotate(lampada, 90, 1);
	set_scale(lampada, 0.7,0.7,0.7);
	set_translate(lampada, -7.2, -8.8, 1.6);
	
			// Faretto di illuminazione quadro e faretto illuminazione spot mongolfiera
	faretto_metal = read_obj("faretto_acciaio.obj", "faretto_metal");
	faretto_metal2 = read_obj("faretto_acciaio.obj", "faretto_metal2");
	set_attribute(faretto_metal, cromatura);	set_attribute(faretto_metal2, cromatura);
	set_scale(faretto_metal, 0.22, 0.22, 0.22);	set_scale(faretto_metal2, 0.22, 0.22, 0.22);
	faretto_light = read_nurbs("faretto_luce.db");	faretto_light2 = read_nurbs("faretto_luce.db");
	set_attribute(faretto_light, tela_bianca);	set_attribute(faretto_light2, tela_bianca);
	set_scale(faretto_light, 0.22, 0.22, 0.22);	set_scale(faretto_light2, 0.22, 0.22, 0.22);
	
	faretto1 = create_list(faretto_metal, "faretto1");
	faretto1 = insert_in_list(faretto1, faretto_light);
	set_x_rotate(faretto1, 35, 1);
	set_y_rotate(faretto1, -15, 1);
	set_translate(faretto1, -7.9,8.0,10.5);
	
	faretto2 = create_list(faretto_metal2, "faretto2");
	faretto2 = insert_in_list(faretto2, faretto_light2);
	set_x_rotate(faretto2, -62, 1);
	set_y_rotate(faretto2, -50, 1);
	set_translate(faretto2, -10.6,7.6,10.6);
	
			// Struttura di sostegno faretti
	barra_faretti = read_obj("barra_faretti.obj", "barra_faretti");
	set_attribute(barra_faretti, cromatura_scura);
	set_scale(barra_faretti, 0.22, 0.22, 0.22);
	set_z_rotate(barra_faretti, 90,1);
	set_translate(barra_faretti, -9.4,7.85,11.55);
	sostegno_faretto1 = read_obj("faretto_sostegno.obj", "sostegno_faretto1");
	sostegno_faretto2 = read_obj("faretto_sostegno.obj", "sostegno_faretto2");
	set_attribute(sostegno_faretto1, cromatura);	set_attribute(sostegno_faretto2, cromatura);
	set_scale(sostegno_faretto1, 0.22, 0.22, 0.3);	set_scale(sostegno_faretto2, 0.22, 0.22, 0.3);
	set_z_rotate(sostegno_faretto1, 75, 1);
	set_translate(sostegno_faretto1, -8,7.85,10.35);
	set_z_rotate(sostegno_faretto2, -55, 1);
	set_translate(sostegno_faretto2, -10.7,7.85,10.35);
	
			// Faretti (lista struttura sostegno faretti e faretti)
	faretti = create_list(barra_faretti, "faretti");
	faretti = insert_in_list(faretto1, faretti);
	faretti = insert_in_list(sostegno_faretto1, faretti);
	faretti = insert_in_list(faretto2, faretti);
	faretti = insert_in_list(sostegno_faretto2, faretti);
	
			// BUSTO
	busto = read_obj("busto.obj", "busto");
	set_attribute(busto,marmo);
	set_z_rotate(busto,-75, 1);
	set_scale(busto,1.5,1.5,1.5);
	set_translate(busto,-18.0, 2.0, 2.8);
	
			// SFERA (usata per provare le textures e gli attributi)
	sfera = read_nurbs("sfera.db");
	//	test cromatura
	set_attribute(sfera, cromatura);
	//	test tela colorata
	//set_attribute(sfera, tela);
	//set_domain_texture(sfera, tela, "textures/tela2.hr",0,0.5,0,0.5,1,0.3,0.4);
	//	test marmo
	//set_attribute(sfera, marmo);
	//	test intonaco
	//set_attribute(sfera, intonaco);
	set_translate(sfera,4.0,-3.0,0.0);
	
			// STANZA

	parete_dx = read_nurbs("murodx.db");
	parete_sx = read_nurbs("murosx.db");
	pavimento = read_nurbs("pav.db");
	parete_post = read_nurbs("muroback.db");
	parete_ant = read_nurbs("murofront.db");
	soffitto = read_nurbs("soffitto.db");

	set_attribute(parete_dx, intonaco);
	set_z_rotate(parete_dx,90,1);	// trasformazione di proiezione
	set_x_rotate(parete_dx,90,1);
	set_projection_texture(parete_dx, intonaco, "textures/carta_muro2.hr",0,1,0.2,0.5);	// 0.2, 0.3
	set_x_rotate(parete_dx,-90,1);	// trasformazione inversa
	set_z_rotate(parete_dx,-90,1);
	
	set_attribute(parete_sx, intonaco);
	set_z_rotate(parete_sx,90,1);	// trasformazione di proiezione
	set_x_rotate(parete_sx,90,1);
	set_projection_texture(parete_sx, intonaco, "textures/carta_muro2.hr",0,1,0.2,0.5);
	set_x_rotate(parete_sx,-90,1);	// trasformazione inversa
	set_z_rotate(parete_sx,-90,1);
	
	set_attribute(parete_ant, intonaco);
	set_domain_texture(parete_ant, intonaco, "textures/carta_muro2.hr",0,0.1,0,0.1,1,0.2,0.5);
	set_attribute(parete_post, intonaco);
	set_domain_texture(parete_post, intonaco, "textures/carta_muro2.hr",0,0.1,0,0.1,1,0.2,0.5);
	set_attribute(soffitto, intonaco);
	set_attribute(pavimento, intonaco);
	set_domain_texture(pavimento, intonaco, "textures/pavimento.hr",0,0.1,0,0.1,1,0.15,0.4);
	//set_domain_texture(pavimento, intonaco, "textures/pavimento1.hr",0,0.1,0,0.1,1,0.2,0.5);
	//set_bump_texture(pavimento, intonaco, "textures/pavimento1_bump.hr",0,0.1,0,0.1,1,0.2,0.3);	// non corretto

	stanza = create_list(pavimento, "stanza");
		stanza = insert_in_list(stanza,parete_sx);
		stanza = insert_in_list(stanza,parete_dx);
		stanza = insert_in_list(stanza,parete_ant);
		stanza = insert_in_list(stanza,parete_post);
		stanza = insert_in_list(stanza,soffitto);
	set_translate(stanza,0.0,0.0,0.005);


			// SCENA FINALE

	scene = create_list(stanza, "scene");
	//scene = insert_in_list(scene, sfera);		// oggetto di test degli attributi
	scene = insert_in_list(scene, mongolfiera);
	scene = insert_in_list(scene, quadro);
	scene = insert_in_list(scene, busto);
	scene = insert_in_list(scene, mobile);
	scene = insert_in_list(scene, tavolino);
	scene = insert_in_list(scene, tavolino2);
	scene = insert_in_list(scene, lampada);
	scene = insert_in_list(scene, faretti);
	
	
	if (save_animation) {	// salvo l'animazione
		int i;
		int max = 24;
		//float cx = 7.13;
		//float cy = -6.33;
		//float cz = 4.12;
		
		
		for (i = 1; i <= max; i++) {
			// modifico l'inquadratura con set_camera(n,cX,cY,cZ,oX,oY,oZ,vX,vY,vZ,z,d)
			//set_camera("Camera", cx,cy,cz,-0.97,-3.35,3.09,-0.11,0.046,0.99,87,1);
			
			// traslo la scena dato che set_camera nn funziona
			if (i < 8) {
				set_translate(scene,i/8.0, 0,(float) -i/22.0);
				set_translate(Luce1,i/8.0, 0,(float) -i/22.0);
				set_translate(Luce2,i/8.0, 0,(float) -i/22.0);
				set_translate(Luce3,i/8.0, 0,(float) -i/22.0);
			} else if (i<16) {
				set_z_rotate(scene,90/8.0, 1);
				set_z_rotate(Luce1,90/8.0, 1);
				set_z_rotate(Luce2,90/8.0, 1);
				set_z_rotate(Luce3,90/8.0, 1);
			} else {
				set_translate(scene, i/20.0, -i/120.0, i/200.0);
				set_translate(Luce1, i/20.0, -i/120.0, i/200.0);
				set_translate(Luce2, i/20.0, -i/120.0, i/200.0);
				set_translate(Luce3, i/20.0, -i/120.0, i/200.0);
			}
			
			// salvo il fotogramma i-esimo
			save_scene_ani(max, "mongolfiera.ani", "mongolfiera", "scena_mongolfiera", scene);
		}
	}
	else {		// salvo la scena
		save_scene("mongolfiera.md","mongolfiera",scene);
	}
	return(0);
}
